; File:     Printer8.asm
;---------------------------------------
   .586
    .model  flat, stdcall
    option  casemap :none
; 
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\comdlg32.inc            ; printer
    
;----------------------------------------------
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\comdlg32.lib             ; printer
    
; 
WinMain         proto   :DWORD,:DWORD,:DWORD,:DWORD
CmdProc         proto   :DWORD,:DWORD,:DWORD,:DWORD 
WndProcA        proto   :DWORD,:DWORD,:DWORD,:DWORD

GetPrinterDC    proto   :DWORD,:DWORD
TextPrint       proto   :DWORD,:DWORD,:DWORD
CreateFontX     proto   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

RclRclCpy       proto   :DWORD,:DWORD
RclRclAdd       proto   :DWORD,:DWORD
CnvToRcl        proto   :DWORD,:DWORD
; ##############################################################################################
.const
MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN     
MAIN_EXTSTYLE    equ 300h

;----------- Menus ---------------------
IDM_Menu1        equ 1001
IDM_Menu2        equ 1002
IDM_Menu3        equ 1003
IDM_Menu4        equ 1004
;---------------------------------------

$ECRAWIDTH$         equ 1268              ; largura do exr
$ECRAHEIGHT$        equ 966               ; altura do ecr

MAXSIZE             equ 260
MAXBUFSIZE          equ 40000
;--------------------------------------
MAXCOLSIZE          equ 120
MAXCOLSIZE4         equ 120 + 4
MAXLINSIZE          equ 5000

MaxRegLst           equ 8
LenRegLst           equ 12
EndRegLst           equ 16
CorRegLst           equ 20
;---------------------------------------
INVALID_SET_FILE_POINTER    equ 0FFFFFFFFh
;.......... To Open File ................
$ArquivoAll      equ FILE_ATTRIBUTE_ARCHIVE or FILE_ATTRIBUTE_READONLY or FILE_ATTRIBUTE_HIDDEN

$ShareFic        equ FILE_SHARE_READ or FILE_SHARE_WRITE 

$AbreOuErro  	equ OPEN_EXISTING       ; Se Existe Abre

$ModoAberRd		equ GENERIC_READ 		            ; Modo de abertura para Leitura
;  Data Section 
.data
_MsgTit1    db 'Erro', 0
_MsgErro    db 'Erro', 0

_MsgTit2    db 'Teste', 0
_MsgTest    db 'Fonte Seleccionada', 0

_MsgTit3    db 'File Error', 0
_MsgTest3   db 'Erro ao Abrir ou Ler o ficheiro', 0

_MsgTit4    db 'File Error', 0
_MsgErro4   db 'The File is too long', 0

_MsgTit5    db 'Test 5', 0
_MsgTest5   db 'Estou aqui', 0

_MsgTit6    db 'Test 6', 0
_MsgTest6   db 'Estou aqui agora', 0
;----------------------------------------------------
_hpdc        dd 0
_hpFont      dd 0

;---------------------------------------
_FontMSSSerif   db 'MS Sans Serif',0

_DocTitle    db 'Documento',0

_mColumns    dd 120             ;Number of columns  160
_mLines      dd 50              ;Number of lines    84
_WidthCharX  dd ?
_HeightCharY dd ?
;.....................................................................................
             dd 120
_TxtToPrint0 db 'Print this text aaaaaaaaaabbbbbbbbbbccccccccccddddddddddeeee'
             db 'Print this text eeeeeeffffffffffgggggggggghhhhhhhhhh12345678'
             dd 26
_TxtToPrint1 db 'Print this text 1 - Line 3'
             dd 31
_TxtToPrint2 db 'Print this text too 2 - Line 20'
             dd 31
_TxtToPrint3 db 'Print this text too 3 - Line 40'
             dd 31
_TxtToPrint4 db 'Print this text too 4 - Line 50'
;....................................................................................
_Text        db '1 - This is the text to be printed .......'
             db '2 - this text is null terminated bl bl bl.....'
             db '3 - bl bl ...this text is null terminated bl bl bl.....'
             db '4 - bl bl ...this text is null terminated bl bl bl.....'
             db '5 - bl bl ...this text is null terminated bl bl bl.....'
             db '6 - bl bl ...this text is null terminated bl bl bl.....'
             db '7 - bl bl ...this text is null terminated bl bl bl.....'
             db '8 - bl bl ...this text is null terminated bl bl bl.....'
             db 0                                                           ; null terminator             
;....................................................................................

_MenuName    db 'Menu',0               ; Definido em rsrc.rc
_hWnd        dd 0

;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Print Text',0

;+++++++++++++++++++++++++++++++++++++++++++++++++++
; see tute_11_3
_OurTitle       db 'Choose the file to open',0

_hFile          dd 0    ; handle
_lFile          dd 0    ; length
_BytesRead      dd 0

_FilterString   db "Text Files", 0, "*.txt",0
                db "asm Files", 0, "*.asm",0
                db "rc Files", 0, "*.rc",0
                db "All Files", 0, "*.*", 0, 0
                ;
                dd MAXSIZE
                dd 0
_FileName       db MAXSIZE dup(0)
                db 0
                
                dd MAXBUFSIZE
                dd 0
_bufferTxt      db MAXBUFSIZE dup(0)
                db 0
                ;
                dd 0                            ; -20 CorRegLst
                dd 0                            ; -16 EndRegLst
                dd MAXCOLSIZE4                  ; -12 LenRegLst
                dd MAXLINSIZE                   ;  -8 MaxRegLst
                dd 0                            ;  -4 
_bufferFrm      db MAXLINSIZE dup ( MAXCOLSIZE4 dup (0) )
                db 0
                ;
                dd 5
                dd 0
_PageNum        db 5 dup (0)
                db 0

                dd 5
_MsgPage        db 'Page '

                dd 10
                dd 0
_PageBuf        db 10 dup (0)
                db 0
;  Data? Section 
.data?
;---------------------------------------
_hInstance   dd ?
;_hdc         dd ?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>

_ofn         OPENFILENAME <?>

_lf          LOGFONT <?>
_di          DOCINFO <?>
_pd          PRINTDLG <?>
_tm          TEXTMETRIC  <?>
_rc          RECT <?>

_PosPrnX     dd ?            ; posio horizontal
_PosPrnY     dd ?            ; posio vertical

_NumPixelX   dd ?
_NumPixelY   dd ?

_LastTxtBuf  dd ?
;_LinCor      dd ?
_PageNumber  dd ?
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax
    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT

; ##############################################################################################
align 16
WinMain     proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            invoke  CreateSolidBrush, 0
        	mov   _wcx.hbrBackground, eax          ; COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            mov    _wcx.hIcon, NULL                         ;eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   0, 0, 1280, 990, NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            invoke    GetPrinterDC, 50, 120

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd
            
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
GetPrinterDC        proc    Lin:DWORD, Col:DWORD
                    ;
                    mov     eax, Lin
                    add     eax, 4
                    mov     _mLines, eax
                    ;
                    mov     eax, Col
                    mov     _mColumns, eax
                    
                    cmp     _hpdc, 0
                    je      short @F
                    ret
                    ;
@@:                 mov     _pd.lStructSize, sizeof PRINTDLG
                    mov     _pd.Flags, PD_RETURNDC or PD_USEDEVMODECOPIES
                    mov     _pd.nCopies, 1

                    invoke  PrintDlg, addr _pd
                    cmp     eax, TRUE
                    je      short @F

                    mov     _hpdc, 0
                    ret

@@:                 mov     eax, _pd.hDC
                    mov     _hpdc, eax
                    ;
                    ; Pixeis na HORIZONTAL
                    ; --------------------
                    invoke  GetDeviceCaps, _hpdc, HORZRES
                    mov     _NumPixelX, eax
                    ;
                    ; Pixeis na VERICAL
                    ; -----------------
	              invoke  GetDeviceCaps, _hpdc, VERTRES
                    mov     _NumPixelY, eax
                    ;
                    ; para termos _mColunas ...
                    ; -------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelX                    
                    div     _mColumns
                    mov     _WidthCharX, eax
                    ;
                    ; para termos _mLinhas ...
                    ; ------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelY                                    
                    div     _mLines
        	        mov    _HeightCharY, eax

                    ; 
                    ; Font
                    ; 
                    mov       eax, _WidthCharX
        	        mov       edx, _HeightCharY
                    neg       edx
                    neg       eax
                    invoke    CreateFontX, addr _FontMSSSerif, edx, eax, FW_NORMAL, 0
                                        
                    jnc       short @F
                    ret
                    ;
@@:                 invoke    SelectObject, _hpdc, _hpFont

                    ;call      SendTeste
                    ret
GetPrinterDC        endp
; 
CreateFontX     proc    pName:DWORD, Alt:DWORD, Lgr:DWORD, Typ:DWORD, ID:DWORD

                mov     eax, Typ
                mov     _lf.lfWeight, eax
                
                mov     eax, Alt
                mov     _lf.lfHeight, eax
                mov     eax, Lgr       
                mov     _lf.lfWidth, eax
                ;
                mov     _lf.lfEscapement, 0
                mov     _lf.lfOrientation, 0
                mov     _lf.lfItalic, FALSE
                mov     _lf.lfUnderline, FALSE
                mov     _lf.lfStrikeOut, FALSE
                mov     _lf.lfCharSet, ANSI_CHARSET 
                mov     _lf.lfOutPrecision, OUT_DEFAULT_PRECIS or OUT_DEVICE_PRECIS
                mov     _lf.lfClipPrecision, CLIP_DEFAULT_PRECIS
                mov     _lf.lfQuality, PROOF_QUALITY        

                mov     al, DEFAULT_PITCH or FF_MODERN
                mov     edx, ID
                cmp     edx, 0
                je      @F
                             
                mov     al, DEFAULT_PITCH or FF_ROMAN
                cmp     edx, 1
                je      @F

                mov     al, DEFAULT_PITCH or FF_SWISS
                cmp     edx, 2
                je      @F

                mov     al, DEFAULT_PITCH or FF_SCRIPT
                cmp     edx, 3
                je      @F

                mov     al, DEFAULT_PITCH or FF_DECORATIVE
                cmp     edx, 4
                je      @F
                
                mov     al, DEFAULT_PITCH or FF_DONTCARE

@@:             mov     _lf.lfPitchAndFamily, al
                ;
                mov     edx, pName
                mov     ebx, offset _lf
                ;
@@:             movzx   eax, byte ptr [edx]                
                mov     byte ptr [ebx].LOGFONT.lfFaceName, al
                ;
                inc     edx
                inc     ebx
                ;
                or      eax, eax
                jnz     short @B

                invoke  CreateFontIndirect, addr _lf
                mov     _hpFont, eax
                ;
                cmp     eax, 0
                jne     short @F

                call    SendErro
                
                stc
                ret
                
@@:             clc
                ret
CreateFontX     endp
; 
PrintText           proc     

                    mov     _PageNumber, 0

                    cmp     _hpdc, 0
                    jne     short @F
                    ret

@@:                 mov     ebx, offset _bufferTxt
                    cmp     dword ptr [ebx - 4], 0
                    jne     short @F
                    ret
                    
@@:                 mov    _di.cbSize, SIZEOF _di
                    mov    _di.lpszDocName, offset _DocTitle
                    mov    _di.lpszOutput, NULL
                    mov    _di.fwType, NULL
                    ;
                    invoke  StartDoc, _hpdc, addr _di
                    cmp     eax, 0
                    jg      short @F
                    ret
                    
@@:                 call    PrintPage
                    jnc     short @B
                    ;
                    ; Remove 
                    ;    
                    invoke   DeleteObject, _hpFont
                    ;
                    invoke   DeleteDC, _hpdc   
                    mov      _hpdc, 0

                    ; 
                    ; Destroy text buffer
                    ; 
                    mov     ebx, offset _bufferTxt
                    mov     dword ptr [ebx - 4], 0

                    ret
PrintText           endp
; 
PrintPage           proc
                    LOCAL   LinCor:DWORD, MaxLin:DWORD
                    ;
                    invoke  StartPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret

@@:                 mov     MaxLin, 49             ;_mLines
                    mov     LinCor, 2

                    inc     _PageNumber
                    invoke  CnvToRcl, _PageNumber, addr _PageNum

                    invoke  RclRclCpy, addr _MsgPage, addr _PageBuf  
                    invoke  RclRclAdd, addr _PageNum, addr _PageBuf  

                    invoke  TextPrint, addr _PageBuf, 1, 95

                    ;
_start:             call    GetNxtLin
                    jnc     short @F
                    ;
                    ; Fim
                    ;
                    invoke  EndPage, _hpdc
                    invoke  EndDoc, _hpdc                    
                    stc
                    ret
                    ;                     
@@:                 invoke  TextPrint, edi, LinCor, 4
                    ;
                    inc     LinCor
                    ;
                    sub     MaxLin, 1
                    jnz     short _start
                    ;
@@:                 invoke  EndPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret
                    ;
@@:                 clc
                    ret
PrintPage           endp
; 
TextPrint           proc    pTxt:DWORD, Lin:DWORD, Col:DWORD

                    mov     ebx, pTxt
                    cmp     dword ptr [ebx - 4], 0
                    jne     short @F
                    clc
                    ret
                    
@@:                 invoke  GetTextMetrics, _hpdc, addr _tm
                    ;
                    mov     ecx, _tm.tmHeight
                    mov     eax, Lin
                    sub     eax, 1
                    mul     ecx                 
                    mov     _PosPrnY, eax
                    ;
                    ;
                    ;
                    mov     ecx, _tm.tmAveCharWidth
                    mov     eax, Col
                    sub     eax, 1
                    mul     ecx
                    mov     _PosPrnX, eax

                    ;mov     ebx, pTxt
                    invoke  TextOut, _hpdc, _PosPrnX, _PosPrnY, ebx, [ebx - 4]
                    clc
                    ret
TextPrint           endp
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu1       ; Printer DC

                    ; 
                    ; Get Printer DC
                    ; 
                    invoke  GetPrinterDC, 50, 120

                case    IDM_Menu2       ; Choose File

                    ; 
                    ; Choose File
                    ; 
                    call    AbreFile

                case    IDM_Menu3       ; Print Text

                    ; 
                    ; Print Text
                    ; 
                    invoke  PrintText
                    
                case    IDM_Menu4       ; Close
                
                    invoke    SendMessage, _hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                ;               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                
                jmp     _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
                ;jmp     _WM_CLOSE
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     cmp     _hpdc, 0
                je      short @F
                ;
                invoke   DeleteDC, _hpdc
@@:
                invoke   DestroyWindow,  hWnd
                jmp     _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                jmp     _ExitProcA 
                
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam                
                ret
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp    
; 
AbreFile        proc

                cmp     _hFile, 0
                je      short @F
                ;
                ; Close the previous            
                ; 
                invoke    CloseHandle, _hFile
                mov       _hFile, 0

                ; 
                ; Clean the previous
                ; 
@@:             mov     ebx, offset _FileName
                mov     dword ptr [ebx - 4], 0

                mov     edx, offset _bufferTxt
                mov     dword ptr [edx - 4], 0

                ; 
                ; Get File Name to open
                ; 
                mov     _ofn.lStructSize, SIZEOF _ofn
                push    _hWnd
                pop     _ofn.hWndOwner

                push    _hInstance
                pop     _ofn.hInstance
                mov     _ofn.lpstrFilter, OFFSET _FilterString
                mov     _ofn.lpstrFile, OFFSET _FileName
                mov     _ofn.nMaxFile, MAXSIZE
                mov     _ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or \
                                    OFN_EXPLORER or OFN_HIDEREADONLY
                mov     _ofn.lpstrTitle, OFFSET _OurTitle
                
                invoke  GetOpenFileName, ADDR _ofn
                cmp     eax, TRUE
                je      short @F
                stc
                ret
                ;
@@:             mov     edx, ebx
                ;
_b:             cmp     byte ptr [edx], 0
                je      short @F
                ;             
                inc     dword ptr [ebx - 4]
                add     edx, 1
                jmp     short _b
                
                ; 
                ; Open File
                ; 
@@:             invoke    CreateFile, ebx, $ModoAberRd, $ShareFic, NULL,
                                           $AbreOuErro, $ArquivoAll, NULL
                cmp       eax, INVALID_HANDLE_VALUE
                je        short _erro                                       ; erro
                ;
                ; Save the handle
                ; 
                mov       _hFile, eax
                mov       ebx, eax
                ;
                ; Get the Length
                ; 
                invoke    SetFilePointer, ebx, 0, NULL, FILE_END
                cmp       eax, INVALID_SET_FILE_POINTER
                jne	  short @F
                ;
                invoke    CloseHandle, _hFile
                mov       _hFile, 0
                
                call      SendErro3                
                stc
                ret
                ;
@@:             mov       _lFile, eax
                invoke    SetFilePointer, ebx, 0, NULL, FILE_BEGIN 

                ; 
                ; Read File
                ; 
                call      FileRead
                jnc       short @F
                ret
                ; 
                ; Format
                ;       
@@:             call      FormatTxt
                ;
                ret
                ;
_erro:          mov       _hFile, 0
                call      SendErro3

                stc
                ret
AbreFile        endp 
; 
FileRead        proc

                mov     eax, _lFile
                mov     ebx, offset _bufferTxt
                cmp     eax, dword ptr [ebx - 8]
                jbe     short @F

                invoke  MessageBox, _hWnd, addr _MsgErro4, addr _MsgTit4, MB_OK
                ;
                ; File is too long
                ; 
_erro:          mov     dword ptr [ebx - 4], 0
                ;
                invoke    CloseHandle, _hFile
                mov       _hFile, 0
                ;
                call      SendErro3
                stc
                ret
                ;
@@:             invoke    ReadFile, _hFile, ebx, _lFile, addr _BytesRead, NULL
                cmp       eax, 0
                jne	  short @F                 ; leu
                ;
                ; Erro
                ; 
                
                jmp       _erro
;.............................................................................
@@:             mov       eax, _BytesRead
                cmp	  eax, _lFile
                je        short @F
                ;
                call      SendErro3                
                stc
                ret
                ;
@@:             mov     edx, offset _bufferTxt
                mov     dword ptr [edx - 4], eax
                ;
                add     eax, edx
                mov     _LastTxtBuf, eax

                ; 
                ; Close file
                ; 
                invoke    CloseHandle, _hFile
                mov       _hFile, 0
                
                ;####################
                ;call    SendTeste
                ;####################
                                
                clc
                ret
FileRead        endp 
; ##############################################################################################
FormatTxt       proc

                mov     edi, offset _bufferFrm
                mov     dword ptr [edi - EndRegLst], 0
                mov     dword ptr [edi - CorRegLst], 0
                ;
                mov     esi, offset _bufferTxt
                cmp     dword ptr [esi - 4], 0
                jne     short _start
                ret
                ;
_start:         call    NxtLinFrm
                jnc     short @F
                ;
                ; File too long
                ;
                ret

@@:             call    FindCRLF
                jnc     short @F
                ;
                ; Fim
                ;
                ret
                ;
@@:             cmp     ecx, 0
                je      short _start

                cmp     ecx, MAXCOLSIZE 
                jbe     short @F
                ;
                ; Line too long
                ;
                stc
                ret
                ;
                ; copy
                ;
@@:             mov     dword ptr [edi - 4], ecx
                ;                
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx]
                mov     byte ptr [edi + ecx], al
                jnz     short @B
;##################
;call    SendTeste5
;##################
                jz      short _start
FormatTxt       endp
; ----------------------------------------------------------------------------------------------
; Input:
;           ESI     - corrente
;
; Output:
;           EBX     - inicial
;           ESI     - prximo
;
;           ECX     - comprimento
;
FindCRLF        proc

                mov     ebx, esi
                xor     ecx, ecx
                jz      short _i
                ;
_n:             add     esi, 1
                cmp     esi, _LastTxtBuf
                jb      short _i
                ;
                mov     ecx, esi
                sub     ecx, ebx
                
                stc
                ret
                ;
_i:             movzx   eax, word ptr [esi]
                ;
                cmp     ax, 0D0Ah
                je      short _e
                
                cmp     ax, 0A0Dh
                jne     short _n
                ;
_e:             mov     ecx, esi
                sub     ecx, ebx
                
                add     esi, 2
                clc                
                ret
FindCRLF        endp
; ----------------------------------------------------------------------------------------------
NxtLinFrm       proc

                mov     edi, offset _bufferFrm
                mov     eax, dword ptr [edi - EndRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - MaxRegLst]
                jbe     short @F
                stc
                ret
                ;
@@:             mov     dword ptr [edi - EndRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                ;
                mov     dword ptr [edi - 4], 0
                ;                
                clc
                ret
NxtLinFrm       endp
; ----------------------------------------------------------------------------------------------
GetNxtLin       proc

                mov     edi, offset _bufferFrm
                mov     eax, dword ptr [edi - CorRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - EndRegLst]
                jbe     short @F
                stc
                ret
                ;
@@:             mov     dword ptr [edi - CorRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                ;                
                clc
                ret
GetNxtLin       endp
; 
; Aco:
;           converte a dword Val para DECIMAL e coloca na string RCL apontada
;           por pRcl. Termina a string com 0 e anula a string se o buffer
;           for insuficiente
;
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
CnvToRcl    proc    Val:DWORD, pRcl:DWORD
            push    ebx
            push    esi
            push    edi

            mov     eax, [esp+16]           ; Val
            mov     edi, [esp+20]           ; pBuf

            test    eax, eax
            jnz     short @F
            
            mov     dword ptr [edi - 4], 1
            mov     word ptr [edi], 30h
            mov     byte ptr [edi + 1], 0        ; terminate the string
            clc
            jnc     _exit

@@:
            mov     ecx, 3435973837
            xor     esi, esi
                        
@@:             mov     ebx, eax
                mul     ecx
                shr     edx, 3
                mov     eax, edx
                lea     edx, [edx*4+edx]
                add     edx, edx
                sub     ebx, edx
                add     bl, '0'
                ;
                push    ebx                 ; To stack
                add     esi, 1
            or      eax, eax
            jnz     short @B
            
            ; Buffer length control 
            cmp     esi, dword ptr [edi - 8]
            jbe     short _go
            ;
@@:         pop     eax                     ; Get from stack
            sub     esi, 1
            jnz     short @B            
            
            mov     dword ptr [edi - 4], 0
            mov     byte ptr [edi], 0           ; terminate the string            
            stc
            jc      short _exit
            ;
            
_go:        mov     dword ptr [edi - 4], esi
                         
@@:         pop     eax                     ; Get from stack
            mov     byte ptr [edi], al
            add     edi, 1
            sub     esi, 1
            jnz     short @B            

            mov     byte ptr [edi], 0           ; terminate the string
            clc
            
_exit:      pop     edi
            pop     esi
            pop     ebx
            ret     8
CnvToRcl    endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclCpy       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx- 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                mov     dword ptr [edx - 4], ecx
                
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B
                
                ret     8
RclRclCpy       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclAdd       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx - 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                mov     eax, dword ptr [edx - 4]                
                add     ecx, eax
                mov     dword ptr [edx - 4], ecx
                ;
                add     edx, eax
                mov     ecx, dword ptr [ebx - 4]                
                ;
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B

                ret     8
RclRclAdd       endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 
SendErro        proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgErro, addr _MsgTit1, MB_OK 	
                ;
                popad
                ret
SendErro        endp
; 
SendTeste       proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest, addr _MsgTit2, MB_OK 	
                ;
                popad
                ret
SendTeste       endp
; 
SendTeste5      proc
                pushfd
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest5, addr _MsgTit5, MB_OK 	
                ;
                popad
                popfd
                ret
SendTeste5      endp
; 
SendTeste6      proc
                pushfd
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest6, addr _MsgTit6, MB_OK 	
                ;
                popad
                popfd
                ret
SendTeste6      endp
; 
SendErro3       proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest3, addr _MsgTit3, MB_OK 	
                ;
                popad
                ret
SendErro3       endp                
; ##############################################################################################
    end     start

